#include "application.h"

#include <iostream>
#include <cassert>

using namespace std;

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

void application::draw_event()
{
    /*
     * REPLACE THE GL CODE BELOW WITH YOUR DDA LINE DRAWING ALGO.
     * YOUR ALGO SHOULD ONLY USE GL POINTS AS IN THE FIRST BLOCK
     * OF CODE BELOW.
     */
    
    /*
     * Draw two red horizontal lines along the top and bottom 
     * of screen by coloring the pixels directly.
     */
    glColor3f(1.0, 0.0, 0.0);
    glBegin(GL_POINTS);

    for (int i = 0; i < this->width; ++i)
    {
        glVertex2f(i, 40); // bottom line
        glVertex2f(i, this->height - 40); // top line
    }

    glEnd();

    /*
     *  Convert the stored mouse clicks into a set of white lines
     *  using the GL implementation of the line drawing algorithm.
     */
    glColor3f(1.0, 1.0, 1.0);
    glBegin(GL_LINES);

    for (size_t i = 0; i < endpoints.size(); i += 2)
    {
        if (i + 1 < endpoints.size())
        {
            glVertex2f(endpoints[i].x, endpoints[i].y);
            glVertex2f(endpoints[i+1].x, endpoints[i+1].y);
        }
    }

    glEnd();
}

void application::mouse_event(
    mouse_button button, mouse_button_state button_state, 
    int x, int y
    )
{
    // store our clicks
    if (button == GLUT_LEFT_BUTTON && button_state == GLUT_DOWN)
        endpoints.push_back(point(x, y));

    cout << "button event: " << button << " " << button_state
        << " " << x << " " << y << endl;
}

void application::keyboard_event(unsigned char key, int x, int y)
{
    // clear our stored clicks
    if (key == 'c')
        endpoints.clear();

    cout << "keyboard event: " << key << " " 
        << x << " " << y << endl;
}
