#ifndef APPLICATION_H
#define APPLICATION_H

#include <vector>

#include "gl_viewer.h"

/*
 * A simple 2D point class.
 */
class point
{
public:
    point(int x, int y) : x(x), y(y)
    {}

    point() : x(0), y(0)
    {}

    int x, y;
}; // class point

/*
 * Where all of our magic happens.
 */
class application : public gl_viewer
{
public:
    application() {}
    virtual ~application() {}

    void draw_event();
    void mouse_event(
        mouse_button button, mouse_button_state button_state, 
        int x, int y
    );
    void keyboard_event(unsigned char key, int x, int y);

private:
    // store our mouse clicks and use them as our line endpoints
    std::vector<point> endpoints;

}; // class application

#endif
